<?php

class UserIdentity extends CUserIdentity {

    const ERROR_STATUS_BANNED = 4;

    private $_id;

    public function getId() {
        return $this->_id;
    }

    public function authenticate() {
        //Uživatel zadal přezdívku
        $u = Uzivatel::model()->findByAttributes(array('Prezdivka' => $this->username));

        //Uživatel zadal Email
        if (!$u) {
            $u = Uzivatel::model()->findByAttributes(array('Email' => $this->username));
        }

        if (!$u) {                                          // Neplatný Email/Přezdívka
            $this->errorCode = self::ERROR_USERNAME_INVALID;
        } else if (!$u->matchesPassword($this->password)) {   // Neplatné Heslo
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
        } else if ($u->aktivni == 0) {                        // Uživatel je blokován
            $this->errorCode = self::ERROR_STATUS_BANNED;
        } else {

            $this->_id = $u->Id_uzivatel;
            $this->username = $u->Prezdivka;
            $this->setState('Id', $u->Id_uzivatel);
            $this->errorCode = self::ERROR_NONE;

            // pokud není dokončena registrace
            if ($u->dokoncena_registrace == 0) {
                Yii::app()->session['ID1Log'] = $u->Id_uzivatel;
                Yii::app()->request->redirect(Yii::app()->request->baseUrl . '/mesto/dokonceni/');
            }

            $mesto_info = Mesto::model()->with('doba')->findByAttributes(array('Id_uzivatel' => $u->Id_uzivatel));
            $uPrava = Prava::model()->findByAttributes(array('Id' => $u->Id_prava));

            //Nastavení základních konstant
            Yii::app()->session['PRAVA'] = $uPrava->attributes;
            Yii::app()->session['skore'] = $u->Skore;
            Yii::app()->session['ID_Mesta'] = $mesto_info['Id_mesto'];
            Yii::app()->session['max_lidi'] = $mesto_info['Max_lidi'];
            Yii::app()->session['max_vojska'] = $mesto_info['Max_vojska'];
            Yii::app()->session['max_prostoru'] = $mesto_info['doba']['Max_misto'];
            Yii::app()->session['zabrany_prostor'] = $mesto_info['Misto'];
            Yii::app()->session['zabrany_prostor_kasarny'] = $mesto_info['Misto_kasarny'];
            Yii::app()->session['max_surovin'] = $mesto_info['Max_surovin'];
            Yii::app()->session['doba'] = $mesto_info['Doba'];
            Yii::app()->session['strankovani'] = 10;

            if (Yii::app()->session['PRAVA']['AdminMenu']) {
                Yii::app()->session['AdminMenu'] = 1;
            } else {
                Yii::app()->session['AdminMenu'] = 0;
            }
        }

        return !$this->errorCode;
    }

}
