<?php

class DobaController extends Controller
{

	public $layout='//layouts/column2';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			'postOnly + delete', // we only allow deletion via POST request
		);
	}

    public function accessRules() {
        return array(
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('delete'),
                'roles' => array('1'),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('index', 'create', 'admin','view','update'),
                'users' => array('@'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        } 
        }

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
		$model=new Doba;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Doba']))
		{
			$model->attributes=$_POST['Doba'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->Id_doba));
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        } 
        }

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Doba']))
		{
			$model->attributes=$_POST['Doba'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->Id_doba));
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        } 
        }

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
             throw new CHttpException(404,'Tato operace není momentálně dostupná.');
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        } 
        }

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
		$model=new Doba('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Doba']))
			$model->attributes=$_GET['Doba'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        }            
        }

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
        if (Yii::app()->session['PRAVA']['EditDoby'] == '1') {
		$model=new Doba('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Doba']))
			$model->attributes=$_GET['Doba'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}else{
            throw new CHttpException(403,'Nedostatečná oprávnění!');
        } 
        }

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Doba the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Doba::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Doba $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='doba-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
