<?php

class PravaController extends Controller {

    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('zobraz'),
                'users' => array('@'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    /**
     * Zobrazovací funkce, pro oprávnění
     * @param type $id
     * @return type
     */
    public function actionZobraz($id) {
        if (Yii::app()->session['PRAVA']['EditPrava'] == '1') {
            if ($_POST) {
                if (isset($_POST['pravaPred'])) {
                    //  Pokud je zvolen některý z výchozích vzorů
                    if ($_POST['pravaPred'] != 0) {
                        $uziv = $this->nactiUzivatele($id);
                        $uziv->Id_prava = $_POST['pravaPred'];
                        if ($uziv->save()) {
                            Yii::app()->user->setFlash('success', 'Práva byla změněna.');
                        }
                    } else {
                        //  Jinak vytvoř nový
                        $PravaVse = Prava::model()->findAll();
                        $model = new Prava;
                        $this->renderPartial('zobraz', array('model' => $model, 'pravaVse' => $PravaVse));
                        return;
                    }
                } else {
                    //Když je odeslán formulář s právypro editaci práv
                    if ($_POST['Id']) {
                        $model = Prava::model()->findByPk($_POST['Id']);
                        $model->unsetAttributes();
                        $model->Id = $_POST['Id'];
                    } else {
                        $model = new Prava;
                    }
                    $model->attributes = $_POST;
                    foreach ($model->attributes as $key => $value) {
                        if ($value === "on") {
                            $model[$key] = 1;
                        }
                    }
                    if ($model->save()) {
                        $uziv = $this->nactiUzivatele($id);
                        $uziv->Id_prava = $model->Id;
                        $uziv->save();
                        Yii::app()->user->setFlash('success', 'Práva byla změněna.');
                    }
                }
            }
            $PravaVse = Prava::model()->findAll();
            $uzivatel = $this->nactiUzivatele($id);
            $model = Prava::model()->findByAttributes(array('Id' => $uzivatel['Id_prava']));
            if (Yii::app()->user->id == $id) {
                Yii::app()->session['PRAVA'] = $model->attributes;
            }
            $this->renderPartial('zobraz', array('model' => $model, 'pravaVse' => $PravaVse));
        }
    }

    /**
     * Funkce načte uživatele dle zadaného ID
     * @param type $id  Id uživatele
     * @return type Uživatel
     */
    private function nactiUzivatele($id) {
        $uzivatel = Uzivatel::model()->findByPk($id);
        if ($uzivatel) {
            return $uzivatel;
        }
    }

}
