<?php

class PrepocetController extends Controller {

    //--------------- TIMER ----------------------


    private $start;
    private $konec;

    function getmicrotime() {
        list($usec, $sec) = explode(" ", microtime());
        return ((float) $usec + (float) $sec);
    }

    function start() {
        $this->start = $this->getmicrotime();
    }

    function konec() {
        $this->konec = $this->getmicrotime();
    }

    function returntime() {
        $time = $this->konec - $this->start;
        return $time;
    }

    // ---------------------------------------------

    protected $suroviny;
    protected $rozdil;
    protected $pocetUz;
    protected $pocetMes;
    protected $predchozi;

    /*
     * fce přepočtu
     */
    public function actionIndex() {
        if(!$this->overServer($_GET['p'])){
            //  @TODO
            // loguj akci
            echo 'Rozejděte se, zde není nic k vidění!';
            return;
        }
        $this->Start(); // nastartuj timer
        $this->pocetUz = 0;
        $this->pocetMes = 0;
        $this->predchozi = "";

        //nactu vsechny uzivatele
        $uzivatel = Uzivatel::model()->findAll();
        for ($i = 0; $i < count($uzivatel); $i++) {
            //nacti mesta uživatele
            $mesto = $this->nactiMesto($uzivatel[$i]->Id_uzivatel);
            if ($mesto):
                for ($m = 0; $m < count($mesto); $m++) {
                    //načti sklad uživatele
                    $this->suroviny = '';
                    $this->suroviny = Sklad::model()->findAllByAttributes(array('Id_mesto' => $mesto[$m]->Id_mesto));
                    //načti surviny ve skladu
                    $pocetCelkem = $this->celkemSurovin($this->suroviny);
                    $this->rozdil = '';
                    $this->rozdil = $mesto[$m]->Max_surovin - $pocetCelkem;
                    if ($this->rozdil >= 0) {
                        $this->pocitadlo($uzivatel[$i]->Id_uzivatel);
                        //pokud je místo je skladu budu něco dělat dál
                        $budovy = Budova::model()->findAllByAttributes(array('Id_mesto' => $mesto[$m]->Id_mesto));
                        $this->upravSklad($budovy);
                        $this->ulozSkladdoDB();
                    }
                }
            endif;
        }
        $this->Konec();
        $log = new Logprepoctu();
        $log->Cas_behu = $this->returntime();
        $log->Pocet_Mest = $this->pocetMes;
        $log->Pocet_uzivatelu = $this->pocetUz;
        $log->Datum = date("Y-m-d H:i:s");
        $log->save();
        echo 'Uživatelů:' . $this->pocetUz . ' | Měst: ' . $this->pocetMes . ' | Za čas: ' . $this->returntime();
        return;
    }
    
    public function actionSmazNeaktivni() {
        if(!$this->overServer($_GET['p'])){
            //  @TODO
            // loguj akci
            echo 'Rozejděte se, zde není nic k vidění!';
            return;
        }
        $uzivatele = Uzivatel::model()->findAll();
        foreach ($uzivatele as $uzivatel) {
            if($uzivatel['dokoncena_registrace'] == '0'){
                $cas = strtotime(date("Y-m-d H:i:s"));
                $registrace = strtotime($uzivatel['Datum_registrace']) + 86400 + 86400; //48hodin
                $rozdil = $cas - $registrace;
               if($rozdil >= 0){
                   $uzivatel->delete();
               } 
            }
        }
    }
    
    /**
     * Ověří, zdali fci volá server
     * @param type $param   oveřovací sekvence
     * @return boolean  ověřeno/ zamítnuto
     */
    private function overServer($param) {
        if($param == '276e760e41891f26043bcb427cbcdb21'){
            return true;
        }else{
            return false;
        }
    }

    /*
     * Uloží suroviny do skladu
     */
    private function ulozSkladdoDB() {
        for ($index = 0; $index < count($this->suroviny); $index++) {
            $this->suroviny[$index]->save();
        }
    }

    /**
     * Počítá počet projitých uživatelů
     * @param type $pred  vrací počet uživatelů
     */
    private function pocitadlo($pred) {
        if ($this->predchozi != $pred) {
            $this->pocetUz++;
            $this->predchozi = $pred;
        }
        $this->pocetMes++;
    }

    /**
     * Vytvoří počet surovin, které budou uloženy po přepočtu
     * @param type $budovy  typ budovy
     */
    private function upravSklad($budovy) {
        //zlato podle počtu lidi
        $this->suroviny[3]->Pocet += $this->upravMax($this->suroviny[4]->Pocet * 1);
        // zbytek podle počtu budov
        for ($index = 0; $index < count($budovy); $index++) {
            switch ($index) {
                case 0:
                    //budova dřevorubec
                    $pocet = $budovy[$index]->Pocet_budov;
                    $val = $pocet * 2;
                    $this->suroviny[4]->Pocet += $this->upravMax($val);
                    break;
                case 1:
                    //budova dřevorubec
                    $pocet = $budovy[$index]->Pocet_budov;
                    $val = $pocet * 10;
                    $this->suroviny[0]->Pocet += $this->upravMax($val);
                    break;
                case 2:
                    //budova Kameník
                    $pocet = $budovy[$index]->Pocet_budov;
                    $val = $pocet * 10;
                    $this->suroviny[1]->Pocet += $this->upravMax($val);
                    break;
                case 4:
                    //budova železný důl
                    $pocet = $budovy[$index]->Pocet_budov;
                    $val = $pocet * 10;
                    $this->suroviny[2]->Pocet += $this->upravMax($val);
                    break;
            }
        }
    }

    /**
     * Upraví maximum přidávaných jednotek
     * @param type $pridavane   přidávané suroviny
     * @return type reálně přidávané
     */
    private function upravMax($pridavane) {
        if ($pridavane < $this->rozdil) {
            $this->rozdil -= $pridavane;
            return $pridavane;
        } else {
            $zbytek = $this->rozdil;
            $this->rozdil = 0;
            return $zbytek;
        }
    }

    /**
     * Sečte počet suroviny, aby něbylo větší jak max
     * @param type $suroviny    suroviny
     * @return type počet surovin
     */
    private function celkemSurovin($suroviny) {
        $pocetCelkem = 0;
        for ($s = 0; $s < count($suroviny); $s++) {
            if ($suroviny[$s]->Id_suroviny != 5) {
                $pocetCelkem += $suroviny[$s]->Pocet;
            }
        }
        return $pocetCelkem;
    }

    /**
     * Načítá město podle id uživatele
     * @param type $idUzivatele ID uživatele
     * @return type město
     */
    private function nactiMesto($idUzivatele) {
        $mesto = Mesto::model()->findAllByAttributes(array('Id_uzivatel' => $idUzivatele));
        return $mesto;
    }

}
