<?php

class UtokController extends Controller {

    protected $jednotkyUtok = array();
    protected $jednotkyObrana = array();
    protected $jednotkyVlastnosti;
    protected $utocnikSila;
    protected $utocnikObrana;
    protected $obranceSila;
    protected $obranceObrana;
    protected $utocnikZbytek;
    protected $obranceZbytek;
    protected $utocnikZiskSur;
    protected $UCINNOST;

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column2';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('index', 'AjaxValidate', 'jednotky', 'boj', 'vysledek', 'archiv'),
                'users' => array('@'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    /**
     *      Generuje základní view
     * zobrazení seznamu měst / výběr uživatele
     */
    public function actionIndex() {
        Yii::app()->session['mestoCil'] = '';
        Yii::app()->session['quest'] = '';
        $this->render('index');
    }

    /**
     * Generuje view pro volbu jednotek k útoku na vybrané město (z indexu)
     */
    public function actionJednotky() {
        if ($_POST) {
            if ($_POST['typUtok'] == 2) {
                $utok = Logutok::model()->findByAttributes(
                        array('Id_utocnik' => Yii::app()->session['ID_Mesta'], 'Typ_utoku' => 2), array('order' => 'Datum DESC',
                    'limit' => '1,0'));

                $cas = strtotime(date("Y-m-d H:i:s"));
                $posledniUtok = strtotime($utok['Datum']) + 86400;
                $rozdil = $cas - $posledniUtok;

                if ($rozdil < 0) {
                    Yii::app()->user->setFlash('err', 'Příběhový útok lze provést pouze jednou denně!');
                    $this->redirect('index');
                } else {
                    $jednotky = Jednotka::model()->with('jednotka')->findAllByAttributes(array('Id_mesto' => Yii::app()->session['ID_Mesta']));
                    Yii::app()->session['typUtoku'] = $_POST['typUtok'];
                    $q = Quest::model()->findAll();
                    $splnene = HotoveQ::model()->findAllByAttributes(array('Id_mesto' => Yii::app()->session['ID_Mesta']));
                    $questy = $this->custom_shuffle($q);
                    $quest = $this->generujQuest($questy, $splnene);
                    Yii::app()->session['quest'] = $quest['Id'];
                    $this->render('jednotky', array('jednotky' => $jednotky, 'mestoOb' => 0, 'quest' => $quest));
                }
            }


            if (isset($_POST['typUtok']) AND isset($_POST['mestoUtok'])) {
                $mestoTest = Mesto::model()->with('uzivatel')->findByAttributes(
                        array('Id_mesto' => $_POST['mestoUtok']), array('condition' => 'uzivatel.Skore >= :sk AND t.Id_uzivatel != :id AND ((X_souradnice BETWEEN -50 AND 50) OR (Y_souradnice BETWEEN -50 AND 50))',
                    'params' => array(':id' => Yii::app()->user->id, ':sk' => Yii::app()->session['skore']))
                );

                if ($mestoTest) {
                    $mestoObrance = Mesto::model()->findByAttributes(array('Id_mesto' => $_POST['mestoUtok']));
                    Yii::app()->session['mestoCil'] = $mestoObrance['Id_mesto'];

                    switch ($_POST['typUtok']) {
                        case 0: //dobývací
                            $jednotky = Jednotka::model()->with('jednotka')->findAllByAttributes(array('Id_mesto' => Yii::app()->session['ID_Mesta']));
                            Yii::app()->session['typUtoku'] = $_POST['typUtok'];
                            break;
                        case 1: //špionážní
                            $jednotky = Jednotka::model()->with('jednotka')->findAllByAttributes(
                                    array('Id_mesto' => Yii::app()->session['ID_Mesta'], 'Typ_jednotky' => 1));
                            Yii::app()->session['typUtoku'] = $_POST['typUtok'];
                            break;
                    }
                    $this->render('jednotky', array('jednotky' => $jednotky, 'mestoOb' => $mestoObrance));
                }
            }
        }
    }

    /**
     * Fce, sloužící k provedení boje na pozadí
     */
    public function actionBoj() {
        if ($_POST) {
            $this->jednotkyUtok = $this->kontrolaJednotek(Yii::app()->session['ID_Mesta'], $_POST, 0);
            $this->jednotkyObrana = $this->kontrolaJednotek(Yii::app()->session['mestoCil'], $_POST, 1);
            $this->jednotkyVlastnosti = $this->vlastnostiJednotek();
            require(Yii::app()->basePath . '/extensions/yr.no/forecast.php');
            $this->UCINNOST = $prumer;

            switch (Yii::app()->session['typUtoku']) {
                case 0: //dobývací
                    if ((!empty($this->jednotkyUtok)) && $this->jednotkyUtok != 0) {
// Utocnik a jeho sila s obranou
                        $this->utocnikSila = $this->ziskatVlastnost($this->jednotkyUtok, $this->jednotkyVlastnosti,1);
                        $this->utocnikObrana = $this->ziskatVlastnost($this->jednotkyUtok, $this->jednotkyVlastnosti, false);
                    } else {
                        $this->utocnikSila = 0;
                        $this->utocnikObrana = 0;
                    }

                    if ((!empty($this->jednotkyObrana)) && $this->jednotkyObrana != 0) {
// Obrance a jeho sila a obrana
                        $this->obranceSila = $this->ziskatVlastnost($this->jednotkyObrana, $this->jednotkyVlastnosti,0);
                        $this->obranceObrana = $this->ziskatVlastnost($this->jednotkyObrana, $this->jednotkyVlastnosti, false);
                    } else {
                        $this->obranceSila = 0;
                        $this->obranceObrana = 0;
                    }

                    $vyhra = 0;
                    if ($this->utocnikSila == $this->obranceObrana) {
                        $vyhra = 2;
                        $this->utocnikZbytek = 0;
                        $this->obranceZbytek = 0;
                    } elseif ($this->utocnikSila > $this->obranceObrana) {
                        $vyhra = 1;
                        $utociciKoef = $this->vypocetKoefMrtvych($this->obranceObrana, $this->utocnikSila);
                        $this->utocnikZbytek = $this->prepocetMrtvych($this->jednotkyUtok, $utociciKoef);
                        $this->obranceZbytek = 0;
                    } else {
                        $vyhra = 0;
                        $braniciKoef = $this->vypocetKoefMrtvych($this->utocnikSila, $this->obranceObrana);
                        $this->obranceZbytek = $this->prepocetMrtvych($this->jednotkyObrana, $braniciKoef);
                        $this->utocnikZbytek = 0;
                    }

                    $this->ulozJednotky($this->jednotkyObrana, $this->obranceZbytek, Yii::app()->session['mestoCil']);
                    $this->ulozJednotky($this->jednotkyUtok, $this->utocnikZbytek, Yii::app()->session['ID_Mesta'], false);
                    $idcko = $this->vytvorLog($vyhra, Yii::app()->session['typUtoku']);
                    $this->vygenerujUpozorneniObranci(Yii::app()->session['mestoCil'], $idcko);
                    $this->vytvorSkore($vyhra, Yii::app()->session['ID_Mesta'], Yii::app()->session['mestoCil'], $this->utocnikZbytek, $this->obranceZbytek);
                    Yii::app()->session['mestoCil'] = "";
                    $this->redirect(array('vysledek', 'id' => $idcko));
                    break;
                case 1: //špionážní
                    $koef = $this->KoefSpion($this->jednotkyObrana);
                    if ($this->jednotkyUtok[1] >= $koef) {
                        $vyhra = 1;
                        $this->obranceZbytek = $this->jednotkyObrana;
                        $this->utocnikZbytek = array('1' => 0);
                        $idcko = $this->vytvorLog($vyhra, Yii::app()->session['typUtoku']);
                        Yii::app()->session['mestoCil'] = "";
                        $this->redirect(array('vysledek', 'id' => $idcko));
//}else ($this->jednotkyUtok[1] < $koef) {
                    } else {
                        $vyhra = 0;
                        $this->obranceZbytek = array('1' => 0);
                        $this->utocnikZbytek = $this->jednotkyUtok;
                        $this->ulozJednotky($this->jednotkyUtok, $this->utocnikZbytek, Yii::app()->session['ID_Mesta'], false);
                        $idcko = $this->vytvorLog($vyhra, Yii::app()->session['typUtoku']);
                        Yii::app()->session['mestoCil'] = "";
                        $this->redirect(array('vysledek', 'id' => $idcko));
                    }
//}else{
// @ TODO když bude mezi (remíza)
//}
                    break;
                case 2:

                    $quest = Quest::model()->findByAttributes(array('Id' => Yii::app()->session['quest']));
                    if ((!empty($this->jednotkyUtok)) && $this->jednotkyUtok != 0) {
                        $this->utocnikSila = $this->ziskatVlastnost($this->jednotkyUtok, $this->jednotkyVlastnosti,1);
                    } else {
                        $this->utocnikSila = 0;
                    }
                    print_r(unserialize($quest['Odmena']));
                    $vyhra = 0;
                    if ($this->utocnikSila >= $quest['Sila']) {
                        $vyhra = 1;
                        $utociciKoef = $this->vypocetKoefMrtvych($quest['Sila'], $this->utocnikSila);
                        $this->utocnikZbytek = $this->prepocetMrtvych($this->jednotkyUtok, $utociciKoef);
                        $this->ulozQuest(Yii::app()->session['ID_Mesta'], Yii::app()->session['quest']);
                        $this->upravSklad(Yii::app()->session['ID_Mesta'], unserialize($quest['Odmena']));
                    } else {
                        $vyhra = 0;
                        $braniciKoef = $this->vypocetKoefMrtvych($this->utocnikSila, $this->obranceObrana);
                        $this->utocnikZbytek = 0;
                    }
                    $this->obranceZbytek = array('1' => 0);
                    $this->utocnikZiskSur = unserialize($quest['Odmena']);
                    $this->ulozJednotky($this->jednotkyUtok, $this->utocnikZbytek, Yii::app()->session['ID_Mesta'], false);
                    $idcko = $this->vytvorLog($vyhra, Yii::app()->session['typUtoku']);
                    Yii::app()->session['mestoCil'] = "";
                    Yii::app()->session['quest'] = '';
                    $this->redirect(array('vysledek', 'id' => $idcko));
                    break;
            }
        }
    }

    /**
     * Fce sloužící pro vygenerování view s náhledem bitvy a zobrazení jejího záznamu
     * @param type $id id útoku
     */
    public function actionVysledek($id) {
        if ($id) {
            $model = Logutok::model()->findByPK($id);
            if (Yii::app()->session['ID_Mesta'] == $model['Id_utocnik'] || Yii::app()->session['ID_Mesta'] == $model['Id_obrance']) {

                $this->render('vysledek', array('model' => $model));
            } else {
                throw new CHttpException(403, 'Pro tuto akci nemáte dostatečná oprávnění');
            }
        } else {
            throw new CHttpException(404, 'Požadovaná stránka neexistuje');
        }
    }

    /**
     * Generuje view s tabulkou všech útoků pro konkrétní město
     */
    public function actionArchiv() {
        $criteria = new CDbCriteria();
        $criteria->order = 'Id DESC';
        $criteria->condition = '(Id_utocnik = :ID OR Id_obrance = :ID)';
        $criteria->params = array(':ID' => Yii::app()->session['ID_Mesta']);

//Zjisti počet záznamů
        $count = Logutok::model()->count($criteria);
//Nastav widget pro stránkování
        $pages = new CPagination($count);
        $pages->pageSize = Yii::app()->session['strankovani'];
        $pages->applyLimit($criteria);
//Načti data z DB
        $model = Logutok::model()->findAll($criteria);

        $this->render('archiv', array('model' => $model, 'pages' => $pages, 'count' => $count, 'pageSize' => $pages->pageSize));
    }

    /**
     * Validovací fce, pro action Index
     */
    public function actionAjaxValidate() {
        if ($_POST) {
            switch ($_POST['N']) {
                case 0:
                    $vys = Mesto::model()->with('uzivatel')->findAllByAttributes(
                            array('Doba' => Yii::app()->session['doba']), array('condition' => 'uzivatel.Skore >= :sk AND t.Id_uzivatel != :id AND ((X_souradnice BETWEEN -50 AND 50) OR (Y_souradnice BETWEEN -50 AND 50))',
                        'params' => array(':id' => Yii::app()->user->id, ':sk' => Yii::app()->session['skore']),
                        'order' => 'Id_mesto ASC')
                    );
                    if (empty($vys)) {
                        $err = "Nebylo nalezeno žádné město";
                    } else {
                        $err = "";
                    }
                    $mess = "nebo vyberte některé z přilehlých měst:";
                    break;

                case 1:
                    $vys = Mesto::model()->with('uzivatel')->findAllByAttributes(
                            array('Doba' => '1'), array('condition' => 'uzivatel.Skore >= :sk AND uzivatel.Prezdivka =:prez AND t.Id_uzivatel != :id',
                        'params' => array(':id' => Yii::app()->user->id, ':prez' => $_POST['prezdivka'], ':sk' => Yii::app()->session['skore']),
                        'order' => 'Id_mesto ASC')
                    );
                    if (empty($vys)) {
                        $err = "Nebylo nalezeno žádné město";
                    } else {
                        $err = "";
                    }
                    $mess = "<br />";
                    break;
                case 2:
                    $err = "<br/> <h3>Byl vybrán příběhový útok.</h3>";
                    $vys = false;
                    break;
            }

            if ($vys) {
                $data_id = array();
                $data_nazev = array();
                $data_prezdivka = array();
                $data_X = array();
                $data_Y = array();
                for ($i = 0; $i < sizeof($vys); $i++) {
                    $data_id[$i] = $vys[$i]['Id_mesto'];
                    $data_X[$i] = $vys[$i]['X_souradnice'];
                    $data_Y[$i] = $vys[$i]['Y_souradnice'];
                    $data_nazev[$i] = $vys[$i]['Nazev'];
                    $data_prezdivka[$i] = $vys[$i]['uzivatel']['Prezdivka'];
                }
                echo json_encode(array(
                    "mess" => $mess,
                    "error_code" => "0",
                    "id" => $data_id,
                    "Nazev" => $data_nazev,
                    "prezdivka" => $data_prezdivka,
                    "X_souradnice" => $data_X,
                    "Y_souradnice" => $data_Y,
                    "nenalezeno" => $err,
                ));
            } else {
                echo json_encode(array(
                    "nenalezeno" => $err));
            }
        }
    }

// ------------------------------------------------
//              Pomocné funkce
// ------------------------------------------------

    /**
     * Upraví sklad přičte/odečte suroviny
     * @param type $mesto   Id města(skladu)
     * @param array $odmena suroviny 
     */
    private function upravSklad($mesto, $odmena) {
        $model = Sklad::model()->findAllByAttributes(array('Id_mesto' => $mesto));
        foreach ($model as $value) {
            if (isset($odmena[$value['Id_suroviny']])) {
                $value['Pocet'] += $odmena[$value['Id_suroviny']];
                $value->save();
            }
        }
    }

    /**
     *  Vytvoří záznam o úspěšném dokončené questu
     * @param type $mesto   ID město
     * @param type $quest   ID quest
     */
    private function ulozQuest($mesto, $quest) {
        $dokonceno = new HotoveQ();
        $dokonceno->Id_mesto = $mesto;
        $dokonceno->Id_q = $quest;
        $dokonceno->Datum = date("Y-m-d H:i:s");
        $dokonceno->save();
    }

    /**
     *  Prohází pořadí prvků v poli
     * @param array $my_array    Pole, které chceme proházet
     * @return array Proházené pole
     */
    private function custom_shuffle($my_array = array()) {
        $copy = array();
        while (count($my_array)) {
            $element = array_rand($my_array);
            $copy[$element] = $my_array[$element];
            unset($my_array[$element]);
        }
        return $copy;
    }

    /**
     * Vygeneruje náhodný, ještě nesplněný, quest
     * @param array $questy  všechny dostupné questy
     * @param array $splnene seznam splněných questů
     * @return array  vrací jeden náhodný quest 
     */
    private function generujQuest($questy, $splnene) {
        foreach ($questy as $quest) {
            if (is_array($splnene)) {
                $test = true;
                foreach ($splnene as $value) {
                    if ($quest['Id'] == $value['Id_q']) {
                        $test = false;
                    }
                }
                if ($test) {
                    return $quest;
                }
            } else {
                return $quest;
            }
        }
    }

    /**
     * Vytvoří koeficient pro výpočet špionážního útoku
     * @param type $jedObrana   Obranné jednotky
     * @return type vrací poměr
     */
    private function KoefSpion($jedObrana) {
        $pocetObrancu = $this->zjistiPocetMrtvych($jedObrana);
        $pomer = $pocetObrancu / 10;
        return $pomer;
    }

    /**
     *  Vytvoří nové skóre pro hráče
     * @param type $vyhra   výhra => True / False
     * @param type $idUtok  ID útočníka (ID města)
     * @param type $idObrance  ID obránce (ID města) 
     * @param array $mrtvyUtok  mrtví útočníci 
     * @param array $mrtviObrana  mrtví obránci
     */
    private function vytvorSkore($vyhra, $idUtok, $idObrance, $mrtvyUtok, $mrtviObrana) {
        $obanciMrtvi = $this->zjistiPocetMrtvych($mrtviObrana);
        $utokMrtvi = $this->zjistiPocetMrtvych($mrtvyUtok);

        $skoreUtok = ($obanciMrtvi * 0.1);
        $skoreObrana = ($utokMrtvi * 0.1);

        if ($vyhra == 1) {
            $skoreUtok += 5;
        } elseif ($vyhra == 0) {
            $skoreObrana += 5;
        } elseif ($vyhra == 2) {
            $skoreObrana += 2;
            $skoreUtok += 2;
        }
        $this->ulozSkore($idUtok, $skoreUtok);
        $this->ulozSkore($idObrance, $skoreObrana);
    }

    /**
     * Uloží skóre hráče
     * @param type $idHrac  ID hráče
     * @param type $skore   Skóre
     */
    private function ulozSkore($idHrac, $skore) {
        $mesto = Mesto::model()->findByAttributes(array('Id_mesto' => $idHrac));
        $uzivatel = Uzivatel::model()->findByAttributes(array('Id_uzivatel' => $mesto->Id_uzivatel));
        $uzivatel->Skore += $skore;
        $uzivatel->save();
    }

    /**
     * Vrací počet vrtvých ze zadaného pole
     * @param type $pole    vstup s mrtvými vojáky
     * @return type součet mrtvol
     */
    public function zjistiPocetMrtvych($pole) {
        $celkem = 0;
        foreach ($pole as $hodnota) {
            $celkem += $hodnota;
        }
        return $celkem;
    }

    /**
     * Fce vrycící barvu pro detail bitevní zprávy
     * @param type $vysledek    výsledek
     * @param type $utocnik     pro obránce hodonoty obráceně
     * @return string           vrací barvu
     */
    public function getBarva($vysledek, $utocnik) {
        if ($utocnik) {
            switch ($vysledek) {
                case 0:
                    return "red";
                case 1:
                    return "green";
                case 2:
                    return "#A3A3A3";
            }
        } else {
            switch ($vysledek) {
                case 0:
                    return "green";
                case 1:
                    return "red";
                case 2:
                    return "#A3A3A3";
            }
        }
    }

    /**
     * FCE zajišťující převod hodnoty na string
     * @param type $vyhra   int odnota výhra
     * @param type $utocnik bool zdali je útočník, pro obránce, obrácené popisky
     * @return string   vrací string pro výpis
     */
    public function zjistiVyhru($vyhra, $utocnik) {
        if ($utocnik) {
            switch ($vyhra) {
                case 0:
                    return 'Prohra';
                case 1:
                    return 'Vítězství';
                case 2:
                    return 'Remíza';
            }
        } else {
            switch ($vyhra) {
                case 0:
                    return 'Vítězství';
                case 1:
                    return 'Prohra';
                case 2:
                    return 'Remíza';
            }
        }
    }

    /**
     * FCE zajišťující převod hodnoty na string
     * @param type $vyhra   int odnota výhra
     * @param type $utocnik bool zdali je útočník, pro obránce, obrácené popisky
     * @return string   vrací string pro výpis
     */
    public function zjistiVyhruSpion($vyhra, $utocnik) {
        if ($utocnik) {
            switch ($vyhra) {
                case 0:
                    return 'Neúspěšný špionážní útok';
                case 1:
                    return 'Úspěšný špionážní útok';
                case 2:
                    return 'Špion byl odhalen, ale...';
            }
        } else {
            switch ($vyhra) {
                case 0:
                    return 'Špionážní útok odhalen';
                case 1:
                    return 'Špionážní útok nebyl odhalen';
                case 2:
                    return 'Špion byl odhalen, ale...';
            }
        }
    }

    /**
     * FCE zajišťující převod hodnoty na string
     * @param type $vyhra   int odnota výhra
     * @param type $utocnik bool zdali je útočník, pro obránce, obrácené popisky
     * @return string   vrací string pro výpis
     */
    public function zjistiVyhruPribeh($vyhra, $utocnik) {
        if ($utocnik) {
            switch ($vyhra) {
                case 0:
                    return 'Úkol nebyl splněn';
                case 1:
                    return 'Úkol byl úspěšně splněn';
            }
        }
    }

    /**
     * Generuje informační zprávu pro obránce
     * @param type $idMesta     id města obránce
     * @param type $idUtoku     id útoku
     */
    private function vygenerujUpozorneniObranci($idMesta, $idUtoku) {
        $mesto = Mesto::model()->with('uzivatel')->findByAttributes(array('Id_mesto' => $idMesta));
        $zprava = new Zprava();
        $zprava->Datum_odeslani = date("Y-m-d H:i:s");
        $zprava->Id_prijemce = $mesto['uzivatel']['Id_uzivatel'];
        $zprava->Prijemce = "-";
        $zprava->Precteno = 0;
        $zprava->Typ_posty = 2;
        $zprava->Predmet = "Na Vaše město byl proveden útok ...";
        $zprava->Text = "Vaše město zaznamenalo útok. <br/>"
                . "Více informací naleznete v <a href='" . Yii::app()->request->baseUrl . "/utok/vysledek/" . $idUtoku . "' target='_top'> bitevní zprávě.</a>";
        $zprava->save();
    }

    /**
     * Vypisuje typ útoku // dočasná fce pokud bude tabulka v DB zrušit tuto fci
     * @param type $typ  //  Id typu útoku
     * @return string    // Vrací string pro view
     */
    public function zjistiTypUtoku($typ) {
        switch ($typ) {
            case 0:
                return "Dobývací";
            case 1:
                return "Špionážní";
            case 2:
                return "Příběhový";
        }
    }

    /**
     *  Vypíše jméno města
     * @param type $id  id Města 
     * @return type     Vrací Název města pro view
     */
    public function zjistiJmenoMesta($id) {
        $model = Mesto::model()->findByPK($id);
        return $model->Nazev;
    }

    /**
     *  Vyvoří záznam z boje v db
     * @param type $vyhra       Výsledek bitvy
     * @param type $typUtoku    Typ útoku
     * @return type             Vrací id záznamu pro přeměrování
     */
    private function vytvorLog($vyhra, $typUtoku) {
        $log = new Logutok();
        $log->Id_obrance = Yii::app()->session['mestoCil'];
        $log->Id_utocnik = Yii::app()->session['ID_Mesta'];
        $log->Vyhra = $vyhra;
        $log->Typ_utoku = $typUtoku;
        $log->Datum = date("Y-m-d H:i:s");
        $log->O_Ztraty_jed = serialize($this->obranceZbytek);
        $log->U_Poslane_jed = serialize($this->jednotkyUtok);
        $log->U_Ztraty_jed = serialize($this->utocnikZbytek);
        $log->U_Zisk_sur = serialize($this->utocnikZiskSur);
        $log->save();
        return $log->Id;
    }

    /**
     *  Funkce sloužící k uložení správného počtu jednotek do DB
     * @param type $jednotky        poslané jednotky do útoku
     * @param type $mrtvi           mrtví vojáci z odeslaných jednotek
     * @param type $idMesto         id města ze kterého jsou jednotky
     * @param type $obrana          Obrana/true, Utok/false
     */
    private function ulozJednotky($jednotky, $mrtvi, $idMesto, $obrana = "true") {
        if ($obrana) {
            $model = Jednotka::model()->findAllByAttributes(array('Id_mesto' => $idMesto));
            if ($mrtvi == 0) {
                foreach ($model as $jednotka) {
                    $this->obranceZbytek = array($jednotka['Typ_jednotky'] => $jednotka['Pocet_jednotek']);
                    $this->upravMistoKasarny($jednotka['Pocet_jednotek'], $jednotka['Typ_jednotky'], $idMesto);
                    $jednotka['Pocet_jednotek'] = 0;
                    $jednotka->save();
                }
            } else {
                foreach ($model as $jednotka) {
                    if ($jednotka['Pocet_jednotek'] < $mrtvi[$jednotka['Typ_jednotky']]) {
                        $mrtvi[$jednotka['Typ_jednotky']] = $model['Pocet_jednotek'];
                    }
                    $jednotka['Pocet_jednotek'] = $jednotka['Pocet_jednotek'] - $mrtvi[$jednotka['Typ_jednotky']];
                    $this->upravMistoKasarny($mrtvi[$jednotka['Typ_jednotky']], $jednotka['Typ_jednotky'], $idMesto);
                    $jednotka->save();
                }
            }
        } else {
            if ($mrtvi == 0) {
                $mrtvi = $jednotky;
                $this->utocnikZbytek = $mrtvi;
            }
            foreach ($mrtvi as $id => $pocet) {
                $model = Jednotka::model()->findByAttributes(array('Id_mesto' => $idMesto, 'Typ_jednotky' => $id));
                if ($model['Pocet_jednotek'] < $pocet) {
                    $pocet = $model['Pocet_jednotek'];
                }
                $model['Pocet_jednotek'] = $model['Pocet_jednotek'] - $pocet;
                $this->upravMistoKasarny($pocet, $id, $idMesto);
                $model->save();
            }
        }
    }

    private function upravMistoKasarny($pocet, $typJednotky, $idMesta) {
        $mesto = Mesto::model()->findByAttributes(array('Id_mesto' => $idMesta));
        $odecet = $pocet * $this->jednotkyVlastnosti[$typJednotky]['Pocet_mist'];
        $mesto->Misto_kasarny = $mesto->Misto_kasarny - $odecet;
        if ($idMesta == Yii::app()->session['ID_Mesta']) {
            Yii::app()->session['zabrany_prostor_kasarny'] = $mesto->Misto_kasarny;
        }
        $mesto->save();
    }

    /**
     * Vypočet koeficientu mrtvych jednotek
     * $vlast1 musí být > $vlast2
     * @param type $vlast1      vlastnost 1
     * @param type $vlast2      vlastnost 2
     * @return double           koeficient
     */
    private function vypocetKoefMrtvych($vlast1, $vlast2) {
        $koefMrtvych = 0;
        if ($vlast2 == 0) {
            return 1;
        }
        $podil = ($vlast1 / $vlast2);
        $koefMrtvych = ($podil) * (sqrt($podil));
        return $koefMrtvych;
    }

    /**
     * Funkce vrací počet mrtvých jednotek z celkem odeslaných
     * @param type $jednotky        jednotky poslané do boje
     * @param type $koefMrtvi       koeficient mrtvolnoti
     * @return type                 počty mrtvých jednotek
     */
    private function prepocetMrtvych($jednotky, $koefMrtvi) {
        $jednotkyMrtvi = array();
        foreach ($jednotky as $id => $pocet) {
            $pocetMrtvich = round($pocet * $koefMrtvi);
            $jednotkyMrtvi[$id] = $pocetMrtvich;
        }
        return $jednotkyMrtvi;
    }

    /**
     * 
     * Vrací celkový počet síly/obrany
     * @param type $jednotky    poslané jednotky do boje
     * @param type $vlastnost   vlastnost jedné jednotky
     * @param type $N přepínač, N = 1 vlastnost omezená účinností podle počasí
     * @param type $sila  true/sila, False/obrana
    */
    private function ziskatVlastnost($jednotky, $vlastnost, $N, $sila = "true") {
        $celkem = 0;
        foreach ($jednotky as $id => $pocet) {
            if ($sila) {
                if($N){
                $vlastnostJedne = $vlastnost[$id]['Sila'] * $this->UCINNOST;
                }  else {
                    $vlastnostJedne = $vlastnost[$id]['Sila'];
                }
            } else {
                $vlastnostJedne = $vlastnost[$id]['Obrana'];
            }
            $celkem += $vlastnostJedne * $pocet;
        }
        return (float) $celkem;
    }

    /**
     * Získá vlastnosti pro konkrétní typ jednotky z databáze
     * @return type vrací vlastnosti konkrétního typu jednotky
     */
    public function vlastnostiJednotek() {
        $jednotkyVlastnosti = array();
        $model = TypJednotky::model()->findAll();
        foreach ($model as $typ) {
            $jednotkyVlastnosti[$typ['Id_typ']] = $typ->attributes;
        }
        return $jednotkyVlastnosti;
    }

    /**
     * Zjistí maximální počet jednotek, které lze odeslat do buje
     * @param type $idMesta     id města
     * @param type $id          typ jednotky
     * @return type             Max počet jednotek
     */
    private function maxJednotek($idMesta, $id) {
        $jednotka = Jednotka::model()->findByAttributes(array('Id_mesto' => $idMesta, 'Typ_jednotky' => $id));
        return $jednotka['Pocet_jednotek'];
    }

    /**
     * Kontroluje, jestli sedí maximum odeslanách uživatelem s maximem možných
     * @param type $idMesta     id města    
     * @param type $jednotky    odeslané jednotky
     * @param type $obrance     pokud se jedná o obránce pošli veškeré dostupné jednotky
     * @return int      vrací jednotky
     */
    private function kontrolaJednotek($idMesta, $jednotky, $obrance) {
        $jednotkyKontrola = array();
        if ($obrance == 1) {
            $jednotky = Jednotka::model()->findAllByAttributes(array('Id_mesto' => $idMesta));
            foreach ($jednotky as $jednotka) {
                $jednotkyKontrola[$jednotka['Typ_jednotky']] = abs($jednotka['Pocet_jednotek']);
            }
            return $jednotkyKontrola;
        }
        foreach ($jednotky as $key => $jednotka) {
            $idJednotky = split("j_", $key, 2);
            $idJednotky = $idJednotky['1'];
            $max = $this->maxJednotek($idMesta, $idJednotky);
            if (empty($max)) {
                $max = 0;
            }
            if ($jednotka > $max) {
                $jednotka = $max;
            }
            $jednotkyKontrola[$idJednotky] = abs($jednotka);
        }
        return $jednotkyKontrola;
    }

}
