<?php
/*
 *              Načtení XML z YR.NO
 */

//URL na API YR.NO
$url = "http://api.yr.no/weatherapi/locationforecast/1.9/?lat=50.49;lon=15.52";
//Cesta k souboru
$file = Yii::app()->basePath . '/extensions/yr.no/feed.xml';
//Když existuje soubor tak zjisti stáří jiank defalní hodina
if (file_exists($file)) {
    $feedmtime = filemtime($file);
}else $feedmtime = "4000";
$current_time = time();

//testujeme jestli je soubor starý a jestli vůbec existuje
if(!file_exists($file) || ($current_time - $feedmtime >= '3600')){
    //ze servru pokud jsou data starší než hodinu nebo neexistuje soubor
    $weather = simplexml_load_file($url);
    $weather->asXML($file);
    //echo "server";
 }else{
     // pokud jsou data mladší než hdinu načítáme ze souboru
    $weather = simplexml_load_file($url);
    //echo "local";
 }


//Zjištění aktuálního času a data
$hodina = strftime("%H", time());
$minuta = strftime("%M", time());
$rok =  strftime("%Y", time());
$mesic =  strftime("%m", time());
$den =  strftime("%d", time());
$DoDen = $den;
$DoRok = $rok;
$DoMes = $mesic;

//Předpověď je pro každou 3. hodinu proto žjistíme v jakém rozmezí hodina je
if($hodina >= 0 AND $hodina < 3){
    $od = '00';
    $do = '03';
}elseif($hodina >= 3 AND $hodina < 6){
    $od = '03';
    $do = '06';
}elseif($hodina >= 6 AND $hodina < 9){
    $od = '06';
    $do = '09';
}elseif($hodina >= 9 AND $hodina < 12){
    $od = '09';
    $do = '12';
}elseif($hodina >= 12 AND $hodina < 15){
    $od = '12';
    $do = '15';
}elseif($hodina >= 15 AND $hodina < 18){
    $od = '15';
    $do = '18';
}elseif($hodina >= 18 AND $hodina < 21){
    $od = '18';
    $do = '21';
}elseif($hodina >= 21){
    $od = '21';
    $do = '00';
    //další den - kontrola měsíců a přestupného roku
    if($mesic == 1 OR $mesic == 3 OR $mesic == 5 OR $mesic == 7 OR $mesic == 8 OR $mesic == 10 OR $mesic == 12){
        if($den == 31){
            $DoDen = date("d",strtotime('tomorrow'));
            $DoMes = date("m",strtotime('tomorrow'));
            if ($mesic == 12) {
                $DoMes = 01;
                $DoRok = date("Y",strtotime('tomorrow'));
            }
        }
    }elseif($mesic == 4 OR $mesic == 6 OR $mesic == 9 OR $mesic == 11){
        if($den == 30){
            $DoDen = date("d",strtotime('tomorrow'));
            $DoMes = date("m",strtotime('tomorrow'));
        }
    }elseif($mesic == 2){
        if($den == 28){
            $DoDen = date("d",strtotime('tomorrow'));
            $DoMes = date("m",strtotime('tomorrow'));
            if (Date("L") == "1") {
                $DoDen = date("d",strtotime('tomorrow'));
                $DoMes = $mesic;
            }
        }if($den == 29){
            $DoDen = date("d",strtotime('tomorrow'));
            $DoMes = date("m",strtotime('tomorrow'));
        }
    }
}
//echo $minuta.'|';echo $hodina.'|';echo $den.'|';echo $mesic.'|';echo $rok.'|';
//echo $DoDen.'|';echo $DoMes.'|';echo $DoRok.'|';
//echo $od.'|';echo $do.'|';

// projdeme všechny předpovědi a získáme 2 požadované teploty
foreach($weather->product->time AS $forecast) {
    $from = $forecast['from'];
    $to = $forecast['to'];
    
    // teplota Od rozmezí
                //2015    -  03      -  31      T  15   :00:00Z
    if(($from == $rok.'-'.$mesic.'-'.$den.'T'.$od.':00:00Z') && ($to == $rok.'-'.$mesic.'-'.$den.'T'.$od.':00:00Z')) {
            $teplotaOd = $forecast->location->temperature['value'];
            $oblacnostOd = $forecast->location->mediumClouds['percent'];
            //print_r($forecast);
        }
    // teplota do rozmezí
                //2015  -  03      -  31      T   15  :00:00Z
    if(($from == $DoRok.'-'.$DoMes.'-'.$DoDen.'T'.$do.':00:00Z') && ($to == $DoRok.'-'.$DoMes.'-'.$DoDen.'T'.$do.':00:00Z')) {
            $teplotaDo = $forecast->location->temperature['value'];
            $oblacnostDo = $forecast->location->mediumClouds['percent'];
            //print_r($forecast);
        }
    // srážky
    if(($from == $rok.'-'.$mesic.'-'.$den.'T'.$od.':00:00Z') && ($to == $DoRok.'-'.$DoMes.'-'.$DoDen.'T'.$do.':00:00Z')) {
            $srazky = $forecast->location->precipitation['value'];
            //print_r($forecast);
    }
}

//zjistíme jakou odnotu má jednotlivá minuta (změna za minutu)
function dilek($od,$do) {
$rozdil = (float)$do - $od;
return $rozdil/180;
}

//podle oblačosti načti text
function oblacnost($o) {
    if($o>=0 AND $o<20){
        return "převážně jasno a bez mráčku";
    }elseif($o>=20 AND $o<40){
        return "převážně jasno, sem tam nějaký ten mráček";
    }elseif($o>=40 AND $o<60){
        return "převážně zataženo s jasně viditelnou oblačností";
    }elseif($o>=60 AND $o<80){
        return "převážně zataženo";
    }elseif($o>=80 AND $o<=100){
        return "převážně zataženo s vysokou pravděpodobností bouřek";
    }
}
//podle srazek moralka
function srazky($o) {
    if($o>=0 AND $o<2.6){
        return 1;
    }elseif($o>=2.6 AND $o<8){
        return 0.90;
    }elseif($o>=8 AND $o<40){
        return 0.7;
    }elseif($o>=40){
        return 0.5;
    }
}
// podel oblačnosti morálka
function oblacnostMoralka($o) {
    if($o>=0 AND $o<20){
        return 1;
    }elseif($o>=20 AND $o<40){
        return 0.98;
    }elseif($o>=40 AND $o<60){
        return 0.96;
    }elseif($o>=60 AND $o<80){
        return 0.94;
    }elseif($o>=80 AND $o<=100){
        return 0.9;
    }
}
//podle teploty delej morálku
function moralka($m) {
    if($m>=30){
        return 0.6;
    }elseif($m>=20 AND $m<30){
        return 0.8;
    }elseif($m>=10 AND $m<20){
        return 1;
    }elseif($m>=0 AND $m<10){
        return 0.8;
    }elseif($m>=-10 AND $m<0){
        return 0.6;
    }elseif($m>=-20 AND $m<-10){
        return 0.5;
    }elseif($m<-20){
        return 0.4;
    }
}

// oprava bugu při nedostupnosti do časových údajů
if (!isset($teplotaDo)){
    $teplotaDo = 0;
}
if (!isset($oblacnostDo)){
    $oblacnostDo=0;
}

// oprava bugu při nedostupnosti od časových údajů
if (!isset($teplotaOd)){
    $teplotaOd = $teplotaDo;
}
if (!isset($oblacnostOd)){
    $oblacnostOd=$oblacnostDo;
}

// oprava bugu při nedostupnosti teplota časových údajů
if (!isset($srazky)){
    $srazky = 0;
}




// Spořítáme jaký je s každou minutou růst/pokles teploty
$pocetMinut = (($hodina-$od)*60) + $minuta;

// Spočítáme teplotu pro aktuální minutu a hodinu
$teplota = (float)((int)(($teplotaOd + (dilek($teplotaOd, $teplotaDo)*$pocetMinut)) * 10)/10);
// Spočítáme mraky pro aktuální minutu a hodinu
$ob = $oblacnostOd + (dilek($oblacnostOd, $oblacnostDo)*$pocetMinut);
// Načtu text oblačnosti
$oblacnost = oblacnost($ob);
$prumer = (moralka($teplota) + oblacnostMoralka($ob) + srazky($srazky)) / 3;

$ucinnost = (float) ((int) ($prumer * 1000)/10);
?>