<?php

/**
 * This is the model class for table "budova".
 *
 * The followings are the available columns in table 'budova':
 * @property integer $Id_budova
 * @property integer $Id_mesto
 * @property integer $Typ_budovy
 * @property integer $Pocet_budov
 */
class Budova extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'budova';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Id_mesto, Typ_budovy', 'required'),
			array('Id_mesto, Typ_budovy, Pocet_budov', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_budova, Id_mesto, Typ_budovy, Pocet_budov', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_budova' => 'Id Budova',
			'Id_mesto' => 'Id Mesto',
			'Typ_budovy' => 'Typ Budovy',
			'Pocet_budov' => 'Pocet Budov',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_budova',$this->Id_budova);
		$criteria->compare('Id_mesto',$this->Id_mesto);
		$criteria->compare('Typ_budovy',$this->Typ_budovy);
		$criteria->compare('Pocet_budov',$this->Pocet_budov);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Budova the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
