<?php

/**
 * This is the model class for table "cena_budov".
 *
 * The followings are the available columns in table 'cena_budov':
 * @property integer $id
 * @property integer $Id_typ_budovy
 * @property integer $Id_suroviny
 * @property integer $Pocet
 */
class CenaBudov extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'cena_budov';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		return array(
			array('Id_typ_budovy, Id_suroviny, Pocet', 'required'),
                        array('Id_suroviny', 'in', 'range'=>array_keys(CHtml::listData(TypSurovin::model()->findAll(), 'Id_suroviny', 'Nazev_suroviny')), 'allowEmpty'=>false),
                        array('Id_typ_budovy', 'in', 'range'=>array_keys(CHtml::listData(TypBudovy::model()->findAll(), 'Id_typ', 'Nazev')), 'allowEmpty'=>false),
			array('Id_typ_budovy, Pocet', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_typ_budovy, Id_suroviny, Pocet', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
{
        return array(
            
                'suroviny' => array(self::BELONGS_TO, 'TypSurovin', 'Id_suroviny'),
                'budova' => array(self::BELONGS_TO, 'TypBudovy', 'Id_typ_budovy'),
        );
}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'Id_typ_budovy' => 'Budova',
			'Id_suroviny' => 'Surovina',
			'Pocet' => 'Počet',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('Id_typ_budovy',$this->Id_typ_budovy);
		$criteria->compare('Id_suroviny',$this->Id_suroviny);
		$criteria->compare('Pocet',$this->Pocet);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return CenaBudov the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
