<?php

/**
 * This is the model class for table "doba".
 *
 * The followings are the available columns in table 'doba':
 * @property integer $Id_doba
 * @property string $Nazev_doba
 * @property integer $Max_misto
 * @property string $Popis
 */
class Doba extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'doba';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Max_misto, Nazev_doba', 'required'),
			array('Max_misto', 'numerical', 'integerOnly'=>true),
			array('Nazev_doba', 'length', 'max'=>50),
			array('Popis', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_doba, Nazev_doba, Max_misto, Popis', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_doba' => 'Id Doba',
			'Nazev_doba' => 'Název',
			'Max_misto' => 'Max Místo',
			'Popis' => 'Popis',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_doba',$this->Id_doba);
		$criteria->compare('Nazev_doba',$this->Nazev_doba,true);
		$criteria->compare('Max_misto',$this->Max_misto);
		$criteria->compare('Popis',$this->Popis,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Doba the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
