<?php

/**
 * This is the model class for table "jednotka".
 *
 * The followings are the available columns in table 'jednotka':
 * @property integer $Id_Jednotka
 * @property integer $Id_mesto
 * @property integer $Typ_jednotky
 * @property integer $Pocet_jednotek
 */
class Jednotka extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'jednotka';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Id_mesto, Typ_jednotky', 'required'),
			array('Id_mesto, Typ_jednotky, Pocet_jednotek', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_Jednotka, Id_mesto, Typ_jednotky, Pocet_jednotek', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return array(
                    'jednotka' => array(self::BELONGS_TO, 'TypJednotky', 'Typ_jednotky'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_Jednotka' => 'Id Jednotka',
			'Id_mesto' => 'Id Mesto',
			'Typ_jednotky' => 'Typ jednotky',
			'Pocet_jednotek' => 'Počet jednotek',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_Jednotka',$this->Id_Jednotka);
		$criteria->compare('Id_mesto',$this->Id_mesto);
		$criteria->compare('Typ_jednotky',$this->Typ_jednotky);
		$criteria->compare('Pocet_jednotek',$this->Pocet_jednotek);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Jednotka the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
