<?php

/**
 * This is the model class for table "logutok".
 *
 * The followings are the available columns in table 'logutok':
 * @property integer $Id
 * @property integer $Id_utocnik
 * @property integer $Id_obrance
 * @property string $Vyhra
 * @property string $U_Ztraty_jed
 * @property string $U_Zisk_sur
 * @property string $U_Poslane_jed
 * @property string $O_Ztraty_jed
 * @property string $Datum
 */
class Logutok extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'logutok';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Id_utocnik, Vyhra, Datum', 'required'),
			array('Id_utocnik, Id_obrance', 'numerical', 'integerOnly'=>true),
			array('Vyhra', 'length', 'max'=>2),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id, Id_utocnik, Id_obrance, Vyhra, U_Ztraty_jed, U_Zisk_sur, U_Poslane_jed, O_Ztraty_jed, Datum', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
            'mesto' => array(self::BELONGS_TO, 'Mesto', 'Id_mesto'),
        );
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id' => 'ID',
			'Id_utocnik' => 'Id Utocnik',
			'Id_obrance' => 'Id Obrance',
			'Vyhra' => 'Vyhra',
			'U_Ztraty_jed' => 'U Ztraty Jed',
			'U_Zisk_sur' => 'U Zisk Sur',
			'U_Poslane_jed' => 'U Poslane Jed',
			'O_Ztraty_jed' => 'O Ztraty Jed',
			'Datum' => 'Datum',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id',$this->Id);
		$criteria->compare('Id_utocnik',$this->Id_utocnik);
		$criteria->compare('Id_obrance',$this->Id_obrance);
		$criteria->compare('Vyhra',$this->Vyhra,true);
		$criteria->compare('U_Ztraty_jed',$this->U_Ztraty_jed,true);
		$criteria->compare('U_Zisk_sur',$this->U_Zisk_sur,true);
		$criteria->compare('U_Poslane_jed',$this->U_Poslane_jed,true);
		$criteria->compare('O_Ztraty_jed',$this->O_Ztraty_jed,true);
		$criteria->compare('Datum',$this->Datum,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Logutok the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
