<?php

/**
 * This is the model class for table "mesto".
 *
 * The followings are the available columns in table 'mesto':
 * @property integer $Id_mesto
 * @property string $Nazev
 * @property integer $Doba
 * @property integer $Misto
 * @property integer $Misto_kasarny
 * @property integer $Max_vojska
 * @property integer $Max_surovin
 * @property integer $Max_lidi
 * @property integer $X_souradnice
 * @property integer $Y_souradnice
 * @property integer $Id_uzivatel
 */
class Mesto extends CActiveRecord
{
    
    public $Heslo = "";
    public $HesloZ = "";
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'mesto';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Nazev, Heslo, HesloZ', 'required', 'on'=>'dokonceni'),
			array('Doba, Misto, Misto_kasarny, Max_vojska, Max_surovin, Max_lidi, X_souradnice, Y_souradnice, Id_uzivatel', 'numerical', 'integerOnly'=>true),
			array('Nazev', 'length', 'max'=>50),
                        array('Heslo, HesloZ', 'length', 'max' => 80),
                        array('Nazev','unique'),
                        array('HesloZ', 'compare', 'compareAttribute'=>'Heslo', 'on'=>'dokonceni', 'message'=>'Hesla se musí shodovat!'),
			array('Id_mesto, Nazev, Doba, Misto, Misto_kasarny, Max_vojska, Max_surovin, Max_lidi, X_souradnice, Y_souradnice, Id_uzivatel', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
                    'doba' => array(self::BELONGS_TO, 'Doba', 'Doba'),
                    'uzivatel' => array(self::BELONGS_TO, 'Uzivatel', 'Id_uzivatel'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_mesto' => 'Id Mesto',
			'Nazev' => 'Název',
			'Doba' => 'Doba',
			'Misto' => 'Misto',
			'Misto_kasarny' => 'Misto Kasarny',
			'Max_vojska' => 'Max Vojska',
			'Max_surovin' => 'Max Surovin',
			'Max_lidi' => 'Max Lidi',
			'X_souradnice' => 'X Souradnice',
			'Y_souradnice' => 'Y Souradnice',
			'Id_uzivatel' => 'Id Uzivatel',
                        'Heslo' => 'Heslo',
                        'HesloZ' => 'Heslo znovu',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_mesto',$this->Id_mesto);
		$criteria->compare('Nazev',$this->Nazev,true);
		$criteria->compare('Doba',$this->Doba);
		$criteria->compare('Misto',$this->Misto);
		$criteria->compare('Misto_kasarny',$this->Misto_kasarny);
		$criteria->compare('Max_vojska',$this->Max_vojska);
		$criteria->compare('Max_surovin',$this->Max_surovin);
		$criteria->compare('Max_lidi',$this->Max_lidi);
		$criteria->compare('X_souradnice',$this->X_souradnice);
		$criteria->compare('Y_souradnice',$this->Y_souradnice);
		$criteria->compare('Id_uzivatel',$this->Id_uzivatel);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Mesto the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
