<?php

/**
 * This is the model class for table "prava".
 *
 * The followings are the available columns in table 'prava':
 * @property integer $Id
 * @property integer $EditaceVsech_Uziv
 * @property integer $Mazani_Uziv
 * @property integer $Banovani_Uziv
 * @property integer $EditDoby
 * @property integer $EditSuroviny
 * @property integer $EditJednotky
 * @property integer $EditBudovy
 * @property integer $EditCena_Budov
 * @property integer $EditCena_Jednotek
 * @property integer $Sprava_Verzi
 * @property integer $Sys_Zpravy
 * @property integer $AdminMenu
 * @property integer $EditQuest
 * @property integer $EditPrava
 * @property string $Popis
 */
class Prava extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'prava';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Popis', 'required'),
			array('EditaceVsech_Uziv, Mazani_Uziv, Banovani_Uziv, EditDoby, EditSuroviny, EditJednotky, EditBudovy, EditCena_Budov, EditCena_Jednotek, Sprava_Verzi, Sys_Zpravy, AdminMenu, EditQuest, EditPrava', 'numerical', 'integerOnly'=>true),
			array('Popis', 'length', 'max'=>15),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id, EditaceVsech_Uziv, Mazani_Uziv, Banovani_Uziv, EditDoby, EditSuroviny, EditJednotky, EditBudovy, EditCena_Budov, EditCena_Jednotek, Sprava_Verzi, Sys_Zpravy, AdminMenu, EditQuest, EditPrava, Popis', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id' => 'ID',
			'EditaceVsech_Uziv' => 'Editace Vsech Uziv',
			'Mazani_Uziv' => 'Mazani Uziv',
			'Banovani_Uziv' => 'Banovani Uziv',
			'EditDoby' => 'Edit Doby',
			'EditSuroviny' => 'Edit Suroviny',
			'EditJednotky' => 'Edit Jednotky',
			'EditBudovy' => 'Edit Budovy',
			'EditCena_Budov' => 'Edit Cena Budov',
			'EditCena_Jednotek' => 'Edit Cena Jednotek',
			'Sprava_Verzi' => 'Sprava Verzi',
			'Sys_Zpravy' => 'Sys Zpravy',
			'AdminMenu' => 'Admin Menu',
			'EditQuest' => 'Edit Quest',
			'EditPrava' => 'Edit Prava',
			'Popis' => 'Popis',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id',$this->Id);
		$criteria->compare('EditaceVsech_Uziv',$this->EditaceVsech_Uziv);
		$criteria->compare('Mazani_Uziv',$this->Mazani_Uziv);
		$criteria->compare('Banovani_Uziv',$this->Banovani_Uziv);
		$criteria->compare('EditDoby',$this->EditDoby);
		$criteria->compare('EditSuroviny',$this->EditSuroviny);
		$criteria->compare('EditJednotky',$this->EditJednotky);
		$criteria->compare('EditBudovy',$this->EditBudovy);
		$criteria->compare('EditCena_Budov',$this->EditCena_Budov);
		$criteria->compare('EditCena_Jednotek',$this->EditCena_Jednotek);
		$criteria->compare('Sprava_Verzi',$this->Sprava_Verzi);
		$criteria->compare('Sys_Zpravy',$this->Sys_Zpravy);
		$criteria->compare('AdminMenu',$this->AdminMenu);
		$criteria->compare('EditQuest',$this->EditQuest);
		$criteria->compare('EditPrava',$this->EditPrava);
		$criteria->compare('Popis',$this->Popis,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Prava the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
