<?php

/**
 * This is the model class for table "sklad".
 *
 * The followings are the available columns in table 'sklad':
 * @property integer $id
 * @property integer $Id_mesto
 * @property integer $Id_suroviny
 * @property integer $Pocet
 */
class Sklad extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'sklad';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Id_mesto, Id_suroviny', 'required'),
			array('Id_mesto, Id_suroviny, Pocet', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, Id_mesto, Id_suroviny, Pocet', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
                    'suroviny' => array(self::BELONGS_TO, 'TypSurovin', 'Id_suroviny'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'Id_mesto' => 'Id Mesto',
			'Id_suroviny' => 'Id Suroviny',
			'Pocet' => 'Pocet',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('Id_mesto',$this->Id_mesto);
		$criteria->compare('Id_suroviny',$this->Id_suroviny);
		$criteria->compare('Pocet',$this->Pocet);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Sklad the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
