<?php

/**
 * This is the model class for table "typ_jednotky".
 *
 * The followings are the available columns in table 'typ_jednotky':
 * @property integer $Id_typ
 * @property string $Nazev
 * @property string $Popis
 * @property integer $Sila
 * @property integer $Obrana
 * @property integer $Pocet_mist
 * @property integer $Batoh
 */
class TypJednotky extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'typ_jednotky';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Sila, Obrana, Pocet_mist, Nazev, Batoh', 'required'),
			array('Sila, Obrana, Pocet_mist, Batoh', 'numerical', 'integerOnly'=>true),
			array('Nazev', 'length', 'max'=>50),
			array('Popis', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_typ, Nazev, Popis, Sila, Obrana, Pocet_mist, Batoh', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_typ' => 'Id Typ',
			'Nazev' => 'Název',
			'Popis' => 'Popis',
			'Sila' => 'Síla',
			'Obrana' => 'Obrana',
			'Pocet_mist' => 'Počet Míst',
			'Batoh' => 'Batoh',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_typ',$this->Id_typ);
		$criteria->compare('Nazev',$this->Nazev,true);
		$criteria->compare('Popis',$this->Popis,true);
		$criteria->compare('Sila',$this->Sila);
		$criteria->compare('Obrana',$this->Obrana);
		$criteria->compare('Pocet_mist',$this->Pocet_mist);
		$criteria->compare('Batoh',$this->Batoh);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return TypJednotky the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
