<?php

/**
 * This is the model class for table "typ_surovin".
 *
 * The followings are the available columns in table 'typ_surovin':
 * @property integer $Id_suroviny
 * @property string $Nazev_suroviny
 * @property string $Popis
 */
class TypSurovin extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'typ_surovin';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Nazev_suroviny', 'required'),
			array('Nazev_suroviny', 'length', 'max'=>50),
			array('Popis', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id_suroviny, Nazev_suroviny, Popis', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id_suroviny' => 'Id Suroviny',
			'Nazev_suroviny' => 'Název suroviny',
			'Popis' => 'Popis',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id_suroviny',$this->Id_suroviny);
		$criteria->compare('Nazev_suroviny',$this->Nazev_suroviny,true);
		$criteria->compare('Popis',$this->Popis,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return TypSurovin the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
