<?php

/**
 * This is the model class for table "verze".
 *
 * The followings are the available columns in table 'verze':
 * @property integer $Id
 * @property string $Nazev
 * @property string $Text
 * @property string $Datum
 * @property integer $Id_autor
 */
class Verze extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'verze';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Nazev, Text', 'required'),
                        array('Text', 'safe'),
			array('Id_autor', 'numerical', 'integerOnly'=>true),
			array('Nazev', 'length', 'max'=>11),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id, Nazev, Text, Datum, Id_autor', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
                    'uzivatel' => array(self::BELONGS_TO, 'Uzivatel', 'Id_autor'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id' => 'ID',
			'Nazev' => 'Název',
			'Text' => 'Text',
			'Datum' => 'Datum',
			'Id_autor' => 'Autor',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Id',$this->Id);
		$criteria->compare('Nazev',$this->Nazev,true);
		$criteria->compare('Text',$this->Text,true);
		$criteria->compare('Datum',$this->Datum,true);
		$criteria->compare('Id_autor',$this->Id_autor);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Verze the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
