<?php
/* @var $this QuestController */
/* @var $model Quest */
/* @var $form CActiveForm */
?>
<script src="//tinymce.cachefly.net/4.1/tinymce.min.js"></script>
<script type="text/javascript">
    tinymce.init({
        selector: "textarea",
        plugins: [
            "advlist autolink lists charmap preview anchor",
            " visualblocks code fullscreen",
            "insertdatetime table contextmenu paste"
        ],
        toolbar: "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent"
    });
</script>
<div class="form">

    <?php
    $form = $this->beginWidget('CActiveForm', array(
        'id' => 'quest-form',
    ));
    ?>

    <p class="note">Položky označené <span class="required">*</span> jsou povinné.</p>

    <?php echo $form->errorSummary($model); ?>

    <div class="row">
        <?php echo $form->labelEx($model, 'Nazev'); ?>
        <?php echo $form->textField($model, 'Nazev', array('size' => 35, 'maxlength' => 35)); ?>
        <?php echo $form->error($model, 'Nazev'); ?>
    </div>

    
    <div class="row">
        <?php echo $form->labelEx($model, 'Sila'); ?>
        <?php echo $form->textField($model, 'Sila'); ?>
        <?php echo $form->error($model, 'Sila'); ?>
        <p>(Vojenská síla potřebná k porazení tohoto questu.)</p>
    </div>

    <div class="row">
        <?php echo $form->labelEx($model, 'Text'); ?>
        <?php echo $form->textArea($model, 'Text', array('rows' => 6, 'cols' => 50)); ?>
        <?php echo $form->error($model, 'Text'); ?>
    </div>

    <div class="row">
        <h3>Odměna:</h3>
        <table border="0">
            <?php
            $odmena = unserialize($model->Odmena);
            for ($i = 0; $i < 5; $i++) {
                $k = $i + 1;
                echo '<tr>';
                echo '<td>';
                echo $suroviny[$i]['Nazev_suroviny'] . ': ';
                echo '</td>';
                echo '<td>';
                if (isset($odmena[$k]) && !is_null($odmena[$k])) {
                    echo '<input type="text" name="' . $suroviny[$i]['Id_suroviny'] . '" value="' . $odmena[$k] . '"/>';
                } else {
                    echo '<input type="text" name="' . $suroviny[$i]['Id_suroviny'] . '"/>';
                }
                echo '</td>';
                echo '</tr>';
            }
            ?>
        </table>
    </div>

    <div class="row buttons">
        <?php echo CHtml::submitButton($model->isNewRecord ? 'Vytvořit' : 'Uložit'); ?>
    </div>

    <?php $this->endWidget(); ?>

</div><!-- form -->